extern unsigned char *gpfaralloc(unsigned long ,unsigned char *);
extern unsigned char *gpfarrealloc(unsigned char *,unsigned long );
extern void gpfarfree(unsigned char *);
extern int is_binary_file(struct __iobuf *);
extern int fread_matrix(struct __iobuf *,float ***,int *,int *,float **,float **);
extern int fwrite_matrix(struct __iobuf *,float **,int ,int ,int ,int ,float *,float *);
extern float *vector(int ,int );
extern void free_vector(float *,int ,int );
extern float *extend_vector(float *,int ,int ,int );
extern float *retract_vector(float *,int ,int ,int );
extern float **matrix(int ,int ,int ,int );
extern void free_matrix(float **,unsigned int ,unsigned int ,unsigned int ,unsigned int );
extern float **extend_matrix(float **,int ,int ,int ,int ,int ,int );
extern float **retract_matrix(float **,int ,int ,int ,int ,int ,int );
extern void b_setpixel(unsigned int ,unsigned int ,unsigned int );
extern void b_makebitmap(unsigned int ,unsigned int ,unsigned int );
extern void b_freebitmap(void);
extern void b_setmaskpixel(unsigned int ,unsigned int ,unsigned int );
extern void b_line(unsigned int ,unsigned int ,unsigned int ,unsigned int );
extern void b_charsize(unsigned int );
extern void b_putc(unsigned int ,unsigned int ,int ,unsigned int );
extern int b_setlinetype(int );
extern void b_setvalue(unsigned int );
extern int b_move(unsigned int ,unsigned int );
extern int b_vector(unsigned int ,unsigned int );
extern int b_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int b_text_angle(int );
extern int com_line(void);
extern int do_line(void);
extern int command(void);
extern void replotrequest(void);
extern void plotrequest(void);
extern void plot3drequest(void);
extern void define(void);
extern void get_data(struct curve_points *);
extern void store2d_point(struct curve_points *,int ,double ,double ,double ,double ,double );
extern void adjust_yrange(struct curve_points *);
extern void grid_nongrid_data(struct surface_points *);
extern void get_3ddata(struct surface_points *);
extern void print_points(int );
extern void print_table(void);
extern void print_3dtable(void);
extern void eval_plots(void);
extern void eval_3dplots(void);
extern void done(int );
extern void parametric_fixup(struct curve_points *,int *,double *,double *);
extern void parametric_3dfixup(struct surface_points *,int *,double *,double *,double *,double *,double *,double *);
extern void do_help(void);
extern void do_system(void);
extern int read_line(unsigned char *);
extern void do_shell(void);
extern struct gnuplot_contours *contour(int ,struct iso_curve *,int ,int ,int ,int ,int ,double *);
extern void add_cntr_point(double ,double );
extern void end_crnt_cntr(void);
extern struct udvt_entry *add_udv(int );
extern struct udft_entry *add_udf(int );
extern union argument *add_action(int );
extern int standard(int );
extern void execute_at(struct at_type *);
extern int get_binary_data(struct surface_points *,struct __iobuf *,struct iso_curve **);
extern void mat_mult(double (*)[4],double (*)[4],double (*)[4]);
extern int do_3dplot(struct surface_points *,int ,double ,double ,double ,double ,double ,double );
extern void draw_month_3dxtics(double );
extern void draw_month_3dytics(double );
extern void draw_month_3dztics(double ,double ,double ,double );
extern void draw_day_3dxtics(double );
extern void draw_day_3dytics(double );
extern void draw_day_3dztics(double ,double ,double ,double );
extern double LogScale(double ,int ,double ,unsigned char *,unsigned char *);
extern void boundary(int );
extern double dbl_raise(double ,int );
extern double make_tics(double ,double ,int ,double );
extern void do_plot(struct curve_points *,int ,double ,double ,double ,double );
extern void plot_impulses(struct curve_points *,int ,int );
extern void plot_lines(struct curve_points *);
extern void plot_steps(struct curve_points *);
extern void plot_bars(struct curve_points *);
extern void plot_boxes(struct curve_points *,int );
extern void plot_points(struct curve_points *);
extern void plot_dots(struct curve_points *);
extern void edge_intersect(struct coordinate *,int ,double *,double *);
extern void edge_intersect_steps(struct coordinate *,int ,double *,double *);
extern int two_edge_intersect_steps(struct coordinate *,int ,double *,double *);
extern int two_edge_intersect(struct coordinate *,int ,double *,double *);
extern void polar_xform(struct curve_points *,int );
extern void draw_ytics(double ,double ,double );
extern void draw_xtics(double ,double ,double );
extern void draw_series_ytics(double ,double ,double );
extern void draw_series_xtics(double ,double ,double );
extern void draw_month_ytics(void);
extern void draw_month_xtics(void);
extern void draw_day_ytics(void);
extern void draw_day_xtics(void);
extern void draw_set_ytics(struct ticmark *);
extern void draw_set_xtics(struct ticmark *);
extern void ytick(double ,unsigned char *,double ,double );
extern void xtick(double ,unsigned char *,double ,double );
extern int help(unsigned char *,unsigned char *,int *);
extern void FreeHelp(void);
/*
Check on this in internal.c
extern int matherr(void);
*/
extern void reset_stack(void);
extern void check_stack(void);
extern struct value *pop(struct value *);
extern void push(struct value *);
extern void f_push(union argument *);
extern void f_pushc(union argument *);
extern void f_pushd1(union argument *);
extern void f_pushd2(union argument *);
extern void f_pushd(union argument *);
extern void f_call(union argument *);
extern void f_calln(union argument *);
extern void f_lnot(void);
extern void f_bnot(void);
extern void f_bool(void);
extern void f_lor(void);
extern void f_land(void);
extern void f_bor(void);
extern void f_xor(void);
extern void f_band(void);
extern void f_uminus(void);
extern void f_eq(void);
extern void f_ne(void);
extern void f_gt(void);
extern void f_lt(void);
extern void f_ge(void);
extern void f_le(void);
extern void f_plus(void);
extern void f_minus(void);
extern void f_mult(void);
extern void f_div(void);
extern void f_mod(void);
extern void f_power(void);
extern void f_factorial(void);
extern int f_jump(union argument *);
extern int f_jumpz(union argument *);
extern int f_jumpnz(union argument *);
extern int f_jtern(union argument *);
extern unsigned char *alloc(unsigned long ,unsigned char *);
extern struct curve_points *cp_alloc(int );
extern int cp_extend(struct curve_points *,int );
extern int cp_free(struct curve_points *);
extern struct iso_curve *iso_alloc(int );
extern int iso_extend(struct iso_curve *,int );
extern int iso_free(struct iso_curve *);
extern struct surface_points *sp_alloc(int ,int ,int ,int );
extern int sp_replace(struct surface_points *,int ,int ,int ,int );
extern int sp_free(struct surface_points *);
extern void save_functions(struct __iobuf *);
extern void save_variables(struct __iobuf *);
extern void save_all(struct __iobuf *);
extern void save_set(struct __iobuf *);
extern void save_set_all(struct __iobuf *);
extern void save_tics(struct __iobuf *,int ,int ,struct ticdef *);
extern void load_file(struct __iobuf *,unsigned char *);
extern struct __iobuf *lf_top(void);
extern void load_file_error(void);
extern int instring(unsigned char *,int );
extern void show_functions(void);
extern void show_at(void);
extern void disp_at(struct at_type *,int );
extern void fpe(void);
extern int evaluate_at(struct at_type *,struct value *);
extern struct value *const_express(struct value *);
extern struct at_type *temp_at(void);
extern struct at_type *perm_at(void);
extern void express(void);
extern void xterm(void);
extern void aterm(void);
extern void bterm(void);
extern void cterm(void);
extern void dterm(void);
extern void eterm(void);
extern void fterm(void);
extern void gterm(void);
extern void hterm(void);
extern void factor(void);
extern void xterms(void);
extern void aterms(void);
extern void bterms(void);
extern void cterms(void);
extern void dterms(void);
extern void eterms(void);
extern void fterms(void);
extern void gterms(void);
extern void hterms(void);
extern void iterms(void);
extern void unary(void);
extern void inter(void);
extern int main(int ,unsigned char **);
extern void interrupt_setup(void);
extern void load_rcfile(void);
extern int scanner(unsigned char *);
extern int get_num(unsigned char *);
extern void substitute(unsigned char *,int );
extern void set_command(void);
extern unsigned char get_style(void);
extern int load_range(double *,double *);
extern void show_command(void);
extern void show_version(void);
extern void f_erf(void);
extern void f_erfc(void);
extern void f_ibeta(void);
extern void f_igamma(void);
extern void f_gamma(void);
extern void f_lgamma(void);
extern void f_rand(void);
extern void f_normal(void);
extern void f_inverse_normal(void);
extern void f_inverse_erf(void);
extern double inverse_normal_func(double );
extern double inverse_error_func(double );
extern void f_real(void);
extern void f_imag(void);
extern void f_arg(void);
extern void f_conjg(void);
extern void f_sin(void);
extern void f_cos(void);
extern void f_tan(void);
extern void f_asin(void);
extern void f_acos(void);
extern void f_atan(void);
extern void f_sinh(void);
extern void f_cosh(void);
extern void f_tanh(void);
extern void f_int(void);
extern void f_abs(void);
extern void f_sgn(void);
extern void f_sqrt(void);
extern void f_exp(void);
extern void f_log10(void);
extern void f_log(void);
extern void f_floor(void);
extern void f_ceil(void);
extern double jzero(double );
extern double pzero(double );
extern double qzero(double );
extern double yzero(double );
extern double rj0(double );
extern double ry0(double );
extern double jone(double );
extern double pone(double );
extern double qone(double );
extern double yone(double );
extern double rj1(double );
extern double ry1(double );
extern void f_besj0(void);
extern void f_besj1(void);
extern void f_besy0(void);
extern void f_besy1(void);
extern int do_point(int ,int ,int );
extern void line_and_point(int ,int ,int );
extern void do_arrow(int ,int ,int ,int ,int );
extern void dumb_set_pixel(int ,int ,int ,int );
#ifdef NOT_NOW
extern void DUMB_options(void);
extern void DUMB_init(void);
extern unsigned char *DUMB_str_state(void);
extern void DUMB_graphics(void);
extern void DUMB_text(void);
extern void DUMB_reset(void);
extern void DUMB_linetype(int );
extern void DUMB_move(int ,int );
extern void DUMB_point(int ,int ,int );
extern void DUMB_vector(int ,int );
extern void DUMB_put_text(int ,int ,unsigned char *);
extern void DUMB_arrow(int ,int ,int ,int );
#endif
extern void QW_pause(void);
extern void QW_text(void);
extern void QW_reset(void);
extern int QW_text_angle(int );
extern void QW_init(void);
extern int is_window(void);
extern void QW_graphics(void);
extern void QW_linetype(int );
extern void QW_move(int ,int );
extern void QW_vector(int ,int );
extern void QW_put_text(unsigned int ,unsigned int ,unsigned char *);
extern void QW_color(int );
extern void QW_mask(int );
extern void qw_graph_line(int ,int ,int ,int ,int );
extern void qw_graph_putc(int ,int ,unsigned char ,int ,int ,int );
extern void put_buttons(void);
extern void do_busy(void);
extern void do_unbusy(void);
extern void my_putc(unsigned int ,unsigned int ,int ,int );
extern void put_logo(void);
#ifdef NOT_NOW
extern void T410X_init(void);
extern void T410X_reset(void);
extern void T410X_graphics(void);
extern void T410X_text(void);
extern void T410X_move(unsigned int ,unsigned int );
extern void T410X_vector(unsigned int ,unsigned int );
extern void T410X_point(unsigned int ,unsigned int ,int );
extern void T410X_linetype(int );
extern void T410X_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int T410X_text_angle(int );
extern void T410X_encode_x_y(unsigned int ,unsigned int );
extern void T410X_encode_int(int );
extern void TEK40init(void);
extern void TEK40graphics(void);
extern void TEK40text(void);
extern void TEK40linetype(int );
extern void TEK40move(unsigned int ,unsigned int );
extern void TEK40vector(unsigned int ,unsigned int );
extern void TEK40put_text(unsigned int ,unsigned int ,unsigned char *);
extern void TEK40reset(void);
extern void BG_text(void);
extern void BG_put_text(unsigned int ,unsigned int ,unsigned char *);
extern void KTEK40graphics(void);
extern void KTEK40Ctext(void);
extern void KTEK40Clinetype(int );
extern void KTEK40Mlinetype(int );
extern void KTEK40reset(void);
extern void SEL_init(void);
extern void SEL_graphics(void);
extern void SEL_text(void);
extern void SEL_reset(void);
extern void VTTEK40init(void);
extern void VTTEK40reset(void);
extern void VTTEK40linetype(int );
extern void VTTEK40put_text(unsigned int ,unsigned int ,unsigned char *);
extern void EPSONinit(void);
extern void EPSONgraphics(void);
extern void EPSONtext(void);
extern void EPSONreset(void);
extern void epson_dump(void);
extern void NECoptions(void);
extern void NECinit(void);
extern void NECgraphics(void);
extern void NECtext(void);
extern void NEClinetype(int );
extern void NECreset(void);
extern void nec_dump(void);
extern void nec_draft_dump(void);
extern void STARCinit(void);
extern void STARCgraphics(void);
extern void STARCtext(void);
extern void STARClinetype(int );
extern void STARCreset(void);
extern void STARC_dump(void);
extern void EPS180graphics(void);
extern void EPS180text(void);
extern void eps180_dump(void);
extern void EPS60graphics(void);
extern void EPS60text(void);
extern void eps60_dump(void);
extern void TANDY60text(void);
extern void HP500Coptions(void);
extern void HP500Cinit(void);
extern void HP500Creset(void);
extern void HP500Clinetype(int );
extern void HP500Cgraphics(void);
extern unsigned char complement(int );
extern void HP500Ctext(void);
extern void HPLJIIoptions(void);
extern void HPLJIIinit(void);
extern void HPLJIIgraphics(void);
extern void HPLJIItext(void);
extern void HPLJIIlinetype(int );
extern void HPLJIIput_text(unsigned int ,unsigned int ,unsigned char *);
extern void HPLJIIputc(unsigned int ,unsigned int ,int ,int );
extern void HPLJIIreset(void);
extern void HPDJgraphics(void);
extern void HPDJtext(void);
extern void HPPJoptions(void);
extern void HPPJinit(void);
extern void HPPJreset(void);
extern void HPPJgraphics(void);
extern void HPPJtext(void);
extern void HPPJlinetype(int );
extern void IMAGEN_init(void);
extern void IM_page(void);
extern void IMAGEN_graphics(void);
extern void IMAGEN_options(void);
extern void IMAGEN_text(void);
extern int IMAGEN_scale(double ,double );
extern void IMAGEN_linetype(int );
extern void IMAGEN_move(unsigned int ,unsigned int );
extern void IMAGEN_vector(unsigned int ,unsigned int );
extern int IMAGEN_text_angle(int );
extern int IMAGEN_justify_text(int );
extern void IMAGEN_put_text(int ,int ,unsigned char *);
extern void IMAGEN_reset(void);
extern void IMP_set_draw_pattern(int ,int );
extern void IMAGEN_mapsinit(void);
extern void IMAGEN_createmap(int ,unsigned short *);
extern void MIF_options(void);
extern void MIF_init(void);
extern void MIF_reset(void);
extern void MIF_graphics(void);
extern void MIF_text(void);
extern void MIF_linetype(int );
extern int MIF_justify_text(int );
extern void MIF_vector(unsigned int ,unsigned int );
extern void MIF_move(unsigned int ,unsigned int );
extern void MIF_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int MF_init(void);
extern int MF_graphics(void);
extern int MF_text(void);
extern int MF_justify_text(int );
extern int MF_text_angle(int );
extern int MF_linetype(int );
extern int MF_scale(double ,double );
extern int MF_move(unsigned int ,unsigned int );
extern int MF_vector(unsigned int ,unsigned int );
extern int MF_arrow(unsigned int ,unsigned int ,unsigned int ,unsigned int ,int );
extern int MF_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int MF_reset(void);
extern void TEXDRAW_init(void);
extern int TEXDRAW_scale(double ,double );
extern void TEXDRAW_graphics(void);
extern void TEXDRAW_text(void);
extern void TEXDRAW_linetype(int );
extern void TEXDRAW_move(unsigned int ,unsigned int );
extern void TEXDRAW_point(unsigned int ,unsigned int ,int );
extern void TEXDRAW_vector(unsigned int ,unsigned int );
extern void TEXDRAW_arrow(int ,int ,int ,int ,int );
extern void TEXDRAW_put_text(int ,int ,unsigned char *);
extern int TEXDRAW_justify_text(int );
extern int TEXDRAW_text_angle(int );
extern void TEXDRAW_reset(void);
extern void EEPIC_init(void);
extern int EEPIC_scale(double ,double );
extern void EEPIC_graphics(void);
extern void EEPIC_text(void);
extern void EEPIC_linetype(int );
extern void EEPIC_move(unsigned int ,unsigned int );
extern void EEPIC_point(unsigned int ,unsigned int ,int );
extern void EEPIC_vector(unsigned int ,unsigned int );
extern void EEPIC_arrow(int ,int ,int ,int ,int );
extern void EEPIC_put_text(int ,int ,unsigned char *);
extern int EEPIC_justify_text(int );
extern int EEPIC_text_angle(int );
extern void EEPIC_reset(void);
extern void LATEX_options(void);
extern void LATEX_init(void);
extern int LATEX_scale(double ,double );
extern void LATEX_graphics(void);
extern void LATEX_text(void);
extern void LATEX_linetype(int );
extern void LATEX_move(unsigned int ,unsigned int );
extern void LATEX_point(unsigned int ,unsigned int ,int );
extern void LATEX_vector(unsigned int ,unsigned int );
extern void LATEX_arrow(int ,int ,int ,int ,int );
extern int LATEX_put_text(int ,int ,unsigned char *);
extern int LATEX_justify_text(int );
extern int LATEX_text_angle(int );
extern void LATEX_reset(void);
extern void EMTEX_init(void);
extern void EMTEX_reset(void);
extern void EMTEX_text(void);
extern void GPIC_options(void);
extern void GPIC_init(void);
extern int GPIC_scale(double ,double );
extern void GPIC_graphics(void);
extern void GPIC_text(void);
extern void GPIC_linetype(int );
extern void GPIC_close_line(void);
extern void GPIC_move(unsigned int ,unsigned int );
extern void GPIC_vector(unsigned int ,unsigned int );
extern void GPIC_arrow(int ,int ,int ,int ,int );
extern void GPIC_put_text(int ,int ,unsigned char *);
extern int GPIC_justify_text(int );
extern int GPIC_text_angle(int );
extern void GPIC_reset(void);
extern void PBMoptions(void);
extern void PBMinit(void);
extern void PBMreset(void);
extern void PBMsetfont(void);
extern void PBMgraphics(void);
extern void PBMmonotext(void);
extern void PBMgraytext(void);
extern void PBMcolortext(void);
extern void PBMtext(void);
extern void PBMlinetype(int );
extern void PBMpoint(int ,int ,int );
extern void PS_options(void);
extern void PS_init(void);
extern void PS_graphics(void);
extern void PS_text(void);
extern void PS_reset(void);
extern int PS_linetype(int );
extern int PS_move(unsigned int ,unsigned int );
extern int PS_vector(unsigned int ,unsigned int );
extern int PS_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int PS_text_angle(int );
extern int PS_justify_text(int );
extern void PS_point(int ,int ,int );
extern void PRE_init(void);
extern void KYO_init(void);
extern void PRE_graphics(void);
extern void PRE_text(void);
extern void PRE_linetype(int );
extern void PRE_move(unsigned int ,unsigned int );
extern void PRE_vector(unsigned int ,unsigned int );
extern void PRE_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int PRE_justify_text(int );
extern void PRE_reset(void);
extern void PSLATEX_options(void);
extern void PSLATEX_init(void);
extern int PSLATEX_scale(double ,double );
extern void PSLATEX_graphics(void);
extern int PSLATEX_put_text(int ,int ,unsigned char *);
extern int PSLATEX_justify_text(int );
extern int PSLATEX_text_angle(int );
extern void PSLATEX_reset(void);
extern void PSLATEX_text(void);
extern void PSTRICKS_init(void);
extern int PSTRICKS_scale(double ,double );
extern void PSTRICKS_graphics(void);
extern void PSTRICKS_text(void);
extern void PSTRICKS_linetype(int );
extern void PSTRICKS_move(unsigned int ,unsigned int );
extern void PSTRICKS_point(unsigned int ,unsigned int ,int );
extern void PSTRICKS_vector(unsigned int ,unsigned int );
extern void PSTRICKS_arrow(int ,int ,int ,int ,int );
extern void PSTRICKS_put_text(int ,int ,unsigned char *);
extern int PSTRICKS_justify_text(int );
extern int PSTRICKS_text_angle(int );
extern void PSTRICKS_reset(void);
extern int TPIC_options(void);
extern int TPIC_init(void);
extern int TPIC_reset(void);
extern int TPIC_text(void);
extern int TPIC_scale(double ,double );
extern int TPIC_graphics(void);
extern int TPIC_move(unsigned int ,unsigned int );
extern int TPIC_vector(unsigned int ,unsigned int );
extern int TPIC_linetype(int );
extern int TPIC_put_text(int ,int ,unsigned char *);
extern int TPIC_text_angle(int );
extern int TPIC_justify_text(int );
extern int TPIC_point(unsigned int ,unsigned int ,int );
extern int TPIC_arrow(int ,int ,int ,int ,int );
extern void tpic_diamond(int );
extern void tpic_plus(int );
extern void tpic_box(int );
extern void tpic_times(int );
extern void tpic_triangle(int );
extern void tpic_star(int );
extern void tpic_hexagon(int );
extern void tpic_circle(int );
extern void tpic_doublecircle(int );
extern void tpic_vercircle(int );
extern void tpic_horcircle(int );
extern void tpic_pluscircle(int );
extern void tpic_timescircle(int );
extern void tpic_starcircle(int );
extern void tpic_dotcircle(int );
extern void tpic_diamondcircle(int );
extern void tpic_boxcircle(int );
extern void tpic_trianglecircle(int );
extern void tpic_hexagoncircle(int );
extern void tpic_plustimescircle(int );
extern void tpic_abspath(unsigned int ,unsigned int );
extern void tpic_path(int ,int );
extern void tpic_flush(void);
extern void tpic_arc(int );
extern void tpic_shade(double );
extern void tpic_pen(int );
extern void tpic_dottedflush(double );
extern void tpic_dashedflush(double );
extern void AED_init(void);
extern void AED_graphics(void);
extern void AED_text(void);
extern void AED_linetype(int );
extern void AED_move(int ,int );
extern void AED_vector(int ,int );
extern void AED_put_text(int ,int ,unsigned char *);
extern void AED_reset(void);
extern void AI_options(void);
extern void AI_init(void);
extern void AI_graphics(void);
extern void AI_text(void);
extern void AI_reset(void);
extern void AI_linetype(int );
extern void AI_move(unsigned int ,unsigned int );
extern void AI_vector(unsigned int ,unsigned int );
extern void AI_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int AI_text_angle(int );
extern int AI_justify_text(int );
extern void COREL_options(void);
extern void COREL_init(void);
extern void COREL_graphics(void);
extern void COREL_text(void);
extern void COREL_reset(void);
extern void COREL_linetype(int );
extern void COREL_move(unsigned int ,unsigned int );
extern void COREL_vector(unsigned int ,unsigned int );
extern void COREL_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int COREL_text_angle(int );
extern int COREL_justify_text(int );
extern void EXCL_init(void);
extern void EXCL_graphics(void);
extern void EXCL_text(void);
extern void EXCL_linetype(int );
extern void EXCL_move(int ,int );
extern void EXCL_vector(int ,int );
extern void EXCL_put_text(unsigned int ,unsigned int ,unsigned char *);
extern void EXCL_reset(void);
extern void HP2648init(void);
extern void HP2648graphics(void);
extern void HP2648text(void);
extern void HP2648linetype(int );
extern void HP2648move(int ,int );
extern void HP2648vector(int ,int );
extern void HP2648put_text(int ,int ,unsigned char *);
extern int HP2648_text_angle(int );
extern void HP2648reset(void);
extern int compact_slope(int *,int *,int *,int *,double );
extern int compact_int(int *,int *,int *,int *);
extern struct _HP26_Buffer_Node *BN_create(int ,int ,int );
extern void BN_delete(struct _HP26_Buffer_Node *);
extern int HP26_flush(struct _HP26_Buffer_Node *);
extern void HP26_handle_overflow(void);
extern int HP26_vector(int ,int );
extern int HP26_move(int ,int );
extern void HP26_init(void);
extern void HP26_graphics(void);
extern void HP26_text(void);
extern void HP26_reset(void);
extern int HP26_text_angle(int );
extern int HP26_put_text(int ,int ,unsigned char *);
extern int HP26_linetype(int );
extern int HP26_line_and_point(int ,int ,int );
extern int HP26_do_point(int ,int ,int );
extern void HPGL2_options(void);
extern void PCL_options(void);
extern void HPGL_init(void);
extern void HPGL2_init(void);
extern void PCL_init(void);
extern void HPGL_graphics(void);
extern void HPGL2_graphics(void);
extern void PCL_graphics(void);
extern void HPGL_text(void);
extern void HPGL2_text(void);
extern void PCL_text(void);
extern void HPGL_linetype(int );
extern void HP75_linetype(int );
extern void HPGL2_linetype(int );
extern void HPGL_put_text(int ,int ,unsigned char *);
extern void HPGL2_put_text(int ,int ,unsigned char *);
extern void HPGL_move(int ,int );
extern void HPGL_vector(int ,int );
extern void HPGL2_move(int ,int );
extern void HPGL2_vector(int ,int );
extern void HPGL2_encode(int );
extern int HPGL_text_angle(int );
extern int HPGL2_text_angle(int );
extern void HPGL_reset(void);
extern void HPGL2_reset(void);
extern void PCL_reset(void);
extern int HPGL2_justify_text(int );
extern void DXY_init(void);
extern void DXY_graphics(void);
extern void DXY_text(void);
extern void DXY_linetype(int );
extern void DXY_move(int ,int );
extern void DXY_vector(int ,int );
extern void DXY_put_text(int ,int ,unsigned char *);
extern int DXY_text_angle(int );
extern void DXY_reset(void);
extern void QMS_init(void);
extern void QMS_graphics(void);
extern void QMS_text(void);
extern void QMS_linetype(int );
extern void QMS_move(int ,int );
extern void QMS_vector(int ,int );
extern void QMS_put_text(unsigned int ,unsigned int ,unsigned char *);
extern void QMS_reset(void);
extern void REGISinit(void);
extern void REGISgraphics(void);
extern void REGIStext(void);
extern void REGISlinetype(int );
extern void REGISmove(int ,int );
extern void REGISvector(int ,int );
extern void REGISput_text(int ,int ,unsigned char *);
extern int REGIStext_angle(int );
extern void REGISreset(void);
extern void REGISoptions(void);
extern void V384_init(void);
extern void V384_graphics(void);
extern void V384_text(void);
extern void V384_linetype(int );
extern void V384_move(unsigned int ,unsigned int );
extern void V384_vector(unsigned int ,unsigned int );
extern void V384_put_text(unsigned int ,unsigned int ,unsigned char *);
extern void V384_reset(void);
extern void TGIF_AddVertex(int ,int );
extern void TGIF_Flush(int );
extern void TGIF_init(void);
extern void TGIF_graphics(void);
extern void TGIF_text(void);
extern void TGIF_reset(void);
extern void TGIF_linetype(int );
extern void TGIF_move(unsigned int ,unsigned int );
extern void TGIF_vector(unsigned int ,unsigned int );
extern void TGIF_put_text(unsigned int ,unsigned int ,unsigned char *);
extern int TGIF_text_angle(int );
extern int TGIF_justify_text(int );
extern void TGIF_arrow(int ,int ,int ,int );
extern void DXF_init(void);
extern void DXF_graphics(void);
extern void DXF_text(void);
extern void DXF_linetype(int );
extern void DXF_move(unsigned int ,unsigned int );
extern void DXF_vector(unsigned int ,unsigned int );
extern void DXF_put_text(int ,int ,unsigned char *);
extern int DXF_text_angle(int );
extern int DXF_justify_text(int );
extern void DXF_reset(void);
#endif
extern void options_null(void);
extern void list_terms(void);
extern int set_term(int );
extern int change_term(unsigned char *,int );
extern void init_terminal(void);
extern void UP_redirect(int );
extern void test_term(void);
extern unsigned char *qnx_init(void);
extern void __qw_no_qwslib(void );
extern int chr_in_str(int ,int );
extern int equals(int ,unsigned char *);
extern int almost_equals(int ,unsigned char *);
extern int isstring(int );
extern int isnumber(int );
extern int isletter(int );
extern int is_definition(int );
extern void copy_str(unsigned char *,int );
extern void quote_str(unsigned char *,int );
extern void quotel_str(unsigned char *,int );
extern void capture(unsigned char *,int ,int );
extern void m_capture(unsigned char **,int ,int );
extern void m_quote_capture(unsigned char **,int ,int );
extern void convert(struct value *,int );
extern void disp_value(struct __iobuf *,struct value *);
extern double real(struct value *);
extern double imag(struct value *);
extern double magnitude(struct value *);
extern double angle(struct value *);
extern struct value *Gcomplex(struct value *,double ,double );
extern struct value *Ginteger(struct value *,int );
extern void os_error(unsigned char *,int );
extern void int_error(unsigned char *,int );
extern void lower_case(unsigned char *);
extern void squash_spaces(unsigned char *);
void add_history(char *);
